/*
One of those Weeks Episode 41: Love that Lava
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep41
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;

	public class OotW41
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		public static const WIN_EVENT = "WonGameEvent";
		public static const LOSE_EVENT = "LostGameEvent";

		private static const START_MAP:Array = new Array(
0,3,0,0,1,0,1,0,2,1,3,0,0,3,1,0,3,2,3,3,
3,0,1,1,2,0,0,0,0,0,2,1,2,2,1,0,1,2,3,2,
1,1,1,0,1,3,2,1,1,3,0,2,3,2,0,1,1,1,3,0,
0,3,2,1,2,0,3,0,2,0,1,3,0,1,2,3,0,1,1,0,
3,3,2,0,0,3,1,0,2,3,2,3,3,0,0,3,0,2,1,3,
2,2,3,0,0,3,0,1,1,1,2,0,3,0,2,0,1,3,1,3,
0,0,0,3,3,0,3,2,1,0,3,2,1,0,3,1,2,0,2,1,
0,2,1,1,2,1,2,0,2,2,0,3,2,2,2,1,0,1,1,0,
2,2,1,1,0,2,3,2,1,2,3,2,1,0,1,1,2,2,3,1,
0,1,2,2,2,3,1,0,0,3,1,2,2,1,0,3,3,3,1,0,
3,3,0,0,3,0,1,2,3,2,2,1,3,0,3,2,1,0,2,3,
1,1,2,1,3,3,1,2,0,1,2,3,3,0,2,0,0,2,0,1,
1,2,3,1,2,3,3,0,2,1,3,0,1,2,3,1,3,3,0,1,
2,2,2,2,2,3,0,2,0,3,3,1,3,2,0,1,2,3,1,3,
1,1,1,2,1,0,1,3,3,0,2,0,1,3,1,3,3,3,2,1);
		private static const PLAYER_START_Y:int = 14;
		private static const PLAYER_START_X:int = 14;

		private static const BSOD_QUOTES:Array = new Array(
"Come here and visit.", " ",
"I won't hurt you...that much.", " ",
"Black and White aren't even colors!", " ",
"Penguins are bad.", " ",
"Penguins can't even fly.", " ",
"Stay away from the penguin.", " ",
"Don't go that way.", " ",
"Watch your step.", " ",
"It's not lava...it's red water. Take a dip!", " ");



// ***** VARIABLES **********************************************************

		private var _map:Array;
		private var _playerX:int;
		private var _playerY:int;
		private var _player_movie:Player;
		
// ***** CONSTRUCTOR ********************************************************

		public function OotW41()
		{
			_map = new Array();
			var tempTile:Tile;
			var indx:int = 0;
			var cntrX;
			
			for (var cntrY:int = 0; cntrY < 15; ++cntrY) {
				for (cntrX = 0; cntrX < 20; ++cntrX) {
					tempTile = new Tile(0);
					tempTile.x = 32 * cntrX;
					tempTile.y = 32 * cntrY;
					addChild(tempTile);
					_map[indx] = tempTile;
					++indx;
				}
			}
			
			// hide top row, bsod tile, and make sure text visible
			for (cntrX = 0; cntrX < 20; ++cntrX)
				_map[cntrX].visible = false;
			_map[15*20-1].visible = false;
			swapChildren(_map[15*20-1], _bsod_text);
			
			_player_movie = new Player();
			addChild(_player_movie);
			_player_movie.addEventListener(Player.JUMP_NORTH_EVENT, handleJumpNorth);
			_player_movie.addEventListener(Player.JUMP_EAST_EVENT, handleJumpEast);
			_player_movie.addEventListener(Player.JUMP_SOUTH_EVENT, handleJumpSouth);
			_player_movie.addEventListener(Player.JUMP_WEST_EVENT, handleJumpWest);
			restartGame();
		}

		public function restartGame():void
		{
			_playerX = PLAYER_START_X;
			_playerY = PLAYER_START_Y;
			_player_movie.x = _playerX * 32;
			_player_movie.y = _playerY * 32;
			_player_movie.setAllowableDirections(
				_playerY > 0, _playerX < 19, _playerY < 13, _playerX > 0);
			for (var cntr:int = 0; cntr < _map.length; ++cntr)
				_map[cntr].setRockState(START_MAP[cntr]);
			_bsod_text.text = "Don't jump";
		}

// ***** Functions - Event handlers *****************************************

		public function handleJumpNorth(evt:Event):void 
		{
			--_playerY;
			update();
		}

		public function handleJumpEast(evt:Event):void 
		{
			++_playerX;
			update();
		}

		public function handleJumpSouth(evt:Event):void 
		{
			++_playerY;
			update();
		}

		public function handleJumpWest(evt:Event):void 
		{
			--_playerX;
			update();
		}

// ***** Functions - General control ****************************************

		public function update()
		{
			_player_movie.x = _playerX * 32;
			_player_movie.y = _playerY * 32;
			_player_movie.setAllowableDirections(
				_playerY > 0, _playerX < 19, _playerY < 14, _playerX > 0);
			for (var cntr:int = 0; cntr < _map.length; ++cntr)
				_map[cntr].nextRockState();
			_bsod_text.text = BSOD_QUOTES[Math.floor(Math.random() * BSOD_QUOTES.length)];
			
			var evt:Event;
			if (_playerY == 0) {
				evt = new Event(WIN_EVENT);
				this.dispatchEvent(evt);
			} else if ((_playerX == 19) && (_playerY == 14)) {
				evt = new Event(LOSE_EVENT);
				this.dispatchEvent(evt);
			} else if (_map[_playerY*20+_playerX].getRockState() != 1) {
				evt = new Event(LOSE_EVENT);
				this.dispatchEvent(evt);
			}
		}
/*
		public function toScore()
		{
			var evt:Event = new Event(SHOW_SCORE_EVENT);
			this.dispatchEvent(evt);
		}
*/
	} // end class
} // end package

