/*
One of those Weeks Episode 41: Love that Lava
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep41
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class Player
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		public static const JUMP_NORTH_EVENT:String = "JumpNorthEvent";
		public static const JUMP_EAST_EVENT:String = "JumpEastEvent";
		public static const JUMP_SOUTH_EVENT:String = "JumpSouthEvent";
		public static const JUMP_WEST_EVENT:String = "JumpWestEvent";

// ***** VARIABLES **********************************************************


// ***** CONSTRUCTOR ********************************************************

		public function Player()
		{
			_north_btn.addEventListener(MouseEvent.MOUSE_UP, handleNorth);
			_east_btn.addEventListener(MouseEvent.MOUSE_UP, handleEast);
			_south_btn.addEventListener(MouseEvent.MOUSE_UP, handleSouth);
			_west_btn.addEventListener(MouseEvent.MOUSE_UP, handleWest);
		}

// ***** Functions - Event Handling *****************************************

		private function handleNorth(evt:Event)
		{
			var evt:Event = new Event(JUMP_NORTH_EVENT);
			this.dispatchEvent(evt);
		}

		private function handleEast(evt:Event)
		{
			var evt:Event = new Event(JUMP_EAST_EVENT);
			this.dispatchEvent(evt);
		}

		private function handleSouth(evt:Event)
		{
			var evt:Event = new Event(JUMP_SOUTH_EVENT);
			this.dispatchEvent(evt);
		}

		private function handleWest(evt:Event)
		{
			var evt:Event = new Event(JUMP_WEST_EVENT);
			this.dispatchEvent(evt);
		}

// ***** Functions - General control ****************************************

		public function setAllowableDirections(north:Boolean, east:Boolean, south:Boolean, west:Boolean)
		{
			_north_btn.visible = north;
			_east_btn.visible = east;
			_south_btn.visible = south;
			_west_btn.visible = west;
		}
	} // end class
} // end package

