/*
One of those Weeks Episode 41: Love that Lava
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep41
{
	// Adobe Imports
	import flash.display.MovieClip;
	
	public class Tile
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		private static const FRAME_NAMES:Array = new Array(
			"Risen", "Sinking", "Sunk", "Submerged");

		public static const ROCK_RISEN:int = 0;
		public static const ROCK_SINKING:int = 1;
		public static const ROCK_SUNK:int = 2;
		public static const ROCK_SUBMERGED:int = 3;

// ***** VARIABLES **********************************************************

		private var _rockState:int;

// ***** CONSTRUCTOR ********************************************************

		public function Tile(rockState:int = ROCK_RISEN)
		{
			setRockState(rockState);
		}

// ***** Functions - General control ****************************************
		
		public function getRockState():int
		{
			return _rockState;
		}
		
		public function setRockState(rockState:int):void
		{
			_rockState = rockState;
			gotoAndPlay(FRAME_NAMES[rockState]);
		}
		
		public function nextRockState():void
		{
			++_rockState;
			if (_rockState > ROCK_SUBMERGED)
				_rockState = ROCK_RISEN;
			gotoAndPlay(FRAME_NAMES[_rockState]);
		}
	} // end class
} // end package
